# Notes #
# Uninstall Does Not Require Admin
# Install May Require Admin
# Finding Installed Apps Requires Admin
# Out-String Preserves Line Breaks



# Hide PowerShell Console [Script Ran Directly] #
Add-Type -Name Window -Namespace Console -MemberDefinition '
[DllImport("Kernel32.dll")]
public static extern IntPtr GetConsoleWindow();
[DllImport("user32.dll")]
public static extern bool ShowWindow(IntPtr hWnd, Int32 nCmdShow);
'
$consolePtr = [Console.Window]::GetConsoleWindow()
[Console.Window]::ShowWindow($consolePtr, 0)



# Press Keys #
$source = @"
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Runtime.InteropServices;
using System.Windows.Forms;
namespace KeyboardSend
{
    public class KeyboardSend
    {
        [DllImport("user32.dll")]
        public static extern void keybd_event(byte bVk, byte bScan, int dwFlags, int dwExtraInfo);
        private const int KEYEVENTF_EXTENDEDKEY = 1;
        private const int KEYEVENTF_KEYUP = 2;
        public static void KeyDown(Keys vKey)
        {
            keybd_event((byte)vKey, 0, KEYEVENTF_EXTENDEDKEY, 0);
        }
        public static void KeyUp(Keys vKey)
        {
            keybd_event((byte)vKey, 0, KEYEVENTF_EXTENDEDKEY | KEYEVENTF_KEYUP, 0);
        }
    }
}
"@



# Assemblies #
Add-Type -TypeDefinition $source -ReferencedAssemblies "System.Drawing"
Add-Type -TypeDefinition $source -ReferencedAssemblies "System.Windows.Forms"



# Effects #
$BorderFixedSimple = [System.Windows.Forms.FormBorderStyle]::FixedSingle
$FlatButton = [System.Windows.Forms.FlatStyle]::Flat
$PopButton = [System.Windows.Forms.FlatStyle]::Standard



# Cursors #
$AppStartingCursor = [System.Windows.Forms.Cursors]::AppStarting
$ArrowCursor = [System.Windows.Forms.Cursors]::Arrow
$CrossCursor = [System.Windows.Forms.Cursors]::Cross
$DefaultCursor = [System.Windows.Forms.Cursors]::Default
$HandCursor = [System.Windows.Forms.Cursors]::Hand
$HelpCursor = [System.Windows.Forms.Cursors]::Help
$HSplitCursor = [System.Windows.Forms.Cursors]::HSplit
$IBeamCursor = [System.Windows.Forms.Cursors]::IBeam
$NoCursor = [System.Windows.Forms.Cursors]::No
$NoMove2DCursor = [System.Windows.Forms.Cursors]::NoMove2D
$NoMoveHorizCursor = [System.Windows.Forms.Cursors]::NoMoveHoriz
$NoMoveVertCursor = [System.Windows.Forms.Cursors]::NoMoveVert
$PanEastCursor = [System.Windows.Forms.Cursors]::PanEast
$PanNECursor = [System.Windows.Forms.Cursors]::PanNE
$PanNorthCursor = [System.Windows.Forms.Cursors]::PanNorth
$PanNWCursor = [System.Windows.Forms.Cursors]::PanNW
$PanSECursor = [System.Windows.Forms.Cursors]::PanSE
$PanSouthCursor = [System.Windows.Forms.Cursors]::PanSouth
$PanSWCursor = [System.Windows.Forms.Cursors]::PanSW
$PanWestCursor = [System.Windows.Forms.Cursors]::PanWest
$SizeAllCursor = [System.Windows.Forms.Cursors]::SizeAll
$SizeNESWCursor = [System.Windows.Forms.Cursors]::SizeNESW
$SizeNSCursor = [System.Windows.Forms.Cursors]::SizeNS
$SizeNWSECursor = [System.Windows.Forms.Cursors]::SizeNWSE
$SizeWECursor = [System.Windows.Forms.Cursors]::SizeWE
$UpArrowCursor = [System.Windows.Forms.Cursors]::UpArrow
$VSplitCursor = [System.Windows.Forms.Cursors]::VSplit
$WaitCursor = [System.Windows.Forms.Cursors]::WaitCursor



# Jargon #
$CurrentIdentity = [Security.Principal.WindowsPrincipal][Security.Principal.WindowsIdentity]::GetCurrent()
$Admin = ([Security.Principal.WindowsPrincipal][Security.Principal.WindowsIdentity]::GetCurrent()).IsInRole([Security.Principal.WindowsBuiltInRole] "Administrator");
$NotAdmin = (!$Admin);
$HostName = [System.Net.Dns]::GetHostName()



# Folders & Files #
$IconsFolder = "" + $PSScriptRoot + "\icons\"
$BatchFileLocation = $PSScriptRoot + "\test.bat"
$CurrentUserAppTextFile = $PSScriptRoot + "\test_currentuser_" + $HostName + ".txt"
$AllUserAppTextFile = $PSScriptRoot + "\test_alluser_" + $HostName + ".txt"
$AppTextFiles = $PSScriptRoot + "\test_*_" + $HostName + ".txt"
$WSResetIcon = [system.drawing.icon]::ExtractAssociatedIcon("C:\Windows\System32\WSReset.exe")



# Easier Alignment #

$R1C1 = New-Object System.Drawing.Size(0,0)
$R1C2 = New-Object System.Drawing.Size(64,0)
$R1C3 = New-Object System.Drawing.Size(128,0)
$R1C4 = New-Object System.Drawing.Size(192,0)
$R1C5 = New-Object System.Drawing.Size(256,0)
$R1C6 = New-Object System.Drawing.Size(320,0)
$R1C7 = New-Object System.Drawing.Size(384,0)
$R1C8 = New-Object System.Drawing.Size(448,0)
$R1C9 = New-Object System.Drawing.Size(512,0)
$R1C10 = New-Object System.Drawing.Size(576,0)
$R1C11 = New-Object System.Drawing.Size(640,0)
$R1C12 = New-Object System.Drawing.Size(704,0)
$R1C13 = New-Object System.Drawing.Size(768,0)
$R1C14 = New-Object System.Drawing.Size(832,0)
$R1C15 = New-Object System.Drawing.Size(896,0)
$R1C16 = New-Object System.Drawing.Size(960,0)
$R1C17 = New-Object System.Drawing.Size(1024,0)

$R1hC1 = New-Object System.Drawing.Size(0,32)
$R1hC2 = New-Object System.Drawing.Size(64,32)
$R1hC3 = New-Object System.Drawing.Size(128,32)
$R1hC4 = New-Object System.Drawing.Size(192,32)
$R1hC5 = New-Object System.Drawing.Size(256,32)
$R1hC6 = New-Object System.Drawing.Size(320,32)
$R1hC7 = New-Object System.Drawing.Size(384,32)
$R1hC8 = New-Object System.Drawing.Size(448,32)
$R1hC9 = New-Object System.Drawing.Size(512,32)
$R1hC10 = New-Object System.Drawing.Size(576,32)
$R1hC11 = New-Object System.Drawing.Size(640,32)
$R1hC12 = New-Object System.Drawing.Size(704,32)
$R1hC13 = New-Object System.Drawing.Size(768,32)
$R1hC14 = New-Object System.Drawing.Size(832,32)
$R1hC15 = New-Object System.Drawing.Size(896,32)
$R1hC16 = New-Object System.Drawing.Size(960,32)
$R1hC17 = New-Object System.Drawing.Size(1024,32)

$R2C1 = New-Object System.Drawing.Size(0,64)
$R2C2 = New-Object System.Drawing.Size(64,64)
$R2C3 = New-Object System.Drawing.Size(128,64)
$R2C4 = New-Object System.Drawing.Size(192,64)
$R2C5 = New-Object System.Drawing.Size(256,64)
$R2C6 = New-Object System.Drawing.Size(320,64)
$R2C7 = New-Object System.Drawing.Size(384,64)
$R2C8 = New-Object System.Drawing.Size(448,64)
$R2C9 = New-Object System.Drawing.Size(512,64)
$R2C10 = New-Object System.Drawing.Size(576,64)
$R2C11 = New-Object System.Drawing.Size(640,64)
$R2C12 = New-Object System.Drawing.Size(704,64)
$R2C13 = New-Object System.Drawing.Size(768,64)
$R2C14 = New-Object System.Drawing.Size(832,64)
$R2C15 = New-Object System.Drawing.Size(896,64)
$R2C16 = New-Object System.Drawing.Size(960,64)
$R2C17 = New-Object System.Drawing.Size(1024,64)

$R2hC1 = New-Object System.Drawing.Size(0,96)
$R2hC2 = New-Object System.Drawing.Size(64,96)
$R2hC3 = New-Object System.Drawing.Size(128,96)
$R2hC4 = New-Object System.Drawing.Size(192,96)
$R2hC5 = New-Object System.Drawing.Size(256,96)
$R2hC6 = New-Object System.Drawing.Size(320,96)
$R2hC7 = New-Object System.Drawing.Size(384,96)
$R2hC8 = New-Object System.Drawing.Size(448,96)
$R2hC9 = New-Object System.Drawing.Size(512,96)
$R2hC10 = New-Object System.Drawing.Size(576,96)
$R2hC11 = New-Object System.Drawing.Size(640,96)
$R2hC12 = New-Object System.Drawing.Size(704,96)
$R2hC13 = New-Object System.Drawing.Size(768,96)
$R2hC14 = New-Object System.Drawing.Size(832,96)
$R2hC15 = New-Object System.Drawing.Size(896,96)
$R2hC16 = New-Object System.Drawing.Size(960,96)
$R2hC17 = New-Object System.Drawing.Size(1024,96)

$R3C1 = New-Object System.Drawing.Size(0,128)
$R3C2 = New-Object System.Drawing.Size(64,128)
$R3C3 = New-Object System.Drawing.Size(128,128)
$R3C4 = New-Object System.Drawing.Size(192,128)
$R3C5 = New-Object System.Drawing.Size(256,128)
$R3C6 = New-Object System.Drawing.Size(320,128)
$R3C7 = New-Object System.Drawing.Size(384,128)
$R3C8 = New-Object System.Drawing.Size(448,128)
$R3C9 = New-Object System.Drawing.Size(512,128)
$R3C10 = New-Object System.Drawing.Size(576,128)
$R3C11 = New-Object System.Drawing.Size(640,128)
$R3C12 = New-Object System.Drawing.Size(704,128)
$R3C13 = New-Object System.Drawing.Size(768,128)
$R3C14 = New-Object System.Drawing.Size(832,128)
$R3C15 = New-Object System.Drawing.Size(896,128)
$R3C16 = New-Object System.Drawing.Size(960,128)
$R3C17 = New-Object System.Drawing.Size(1024,128)

$R3hC1 = New-Object System.Drawing.Size(0,160)
$R3hC2 = New-Object System.Drawing.Size(64,160)
$R3hC3 = New-Object System.Drawing.Size(128,160)
$R3hC4 = New-Object System.Drawing.Size(192,160)
$R3hC5 = New-Object System.Drawing.Size(256,160)
$R3hC6 = New-Object System.Drawing.Size(320,160)
$R3hC7 = New-Object System.Drawing.Size(384,160)
$R3hC8 = New-Object System.Drawing.Size(448,160)
$R3hC9 = New-Object System.Drawing.Size(512,160)
$R3hC10 = New-Object System.Drawing.Size(576,160)
$R3hC11 = New-Object System.Drawing.Size(640,160)
$R3hC12 = New-Object System.Drawing.Size(704,160)
$R3hC13 = New-Object System.Drawing.Size(768,160)
$R3hC14 = New-Object System.Drawing.Size(832,160)
$R3hC15 = New-Object System.Drawing.Size(896,160)
$R3hC16 = New-Object System.Drawing.Size(960,160)
$R3hC17 = New-Object System.Drawing.Size(1024,160)

$R4C1 = New-Object System.Drawing.Size(0,192)
$R4C2 = New-Object System.Drawing.Size(64,192)
$R4C3 = New-Object System.Drawing.Size(128,192)
$R4C4 = New-Object System.Drawing.Size(192,192)
$R4C5 = New-Object System.Drawing.Size(256,192)
$R4C6 = New-Object System.Drawing.Size(320,192)
$R4C7 = New-Object System.Drawing.Size(384,192)
$R4C8 = New-Object System.Drawing.Size(448,192)
$R4C9 = New-Object System.Drawing.Size(512,192)
$R4C10 = New-Object System.Drawing.Size(576,192)
$R4C11 = New-Object System.Drawing.Size(640,192)
$R4C12 = New-Object System.Drawing.Size(704,192)
$R4C13 = New-Object System.Drawing.Size(768,192)
$R4C14 = New-Object System.Drawing.Size(832,192)
$R4C15 = New-Object System.Drawing.Size(896,192)
$R4C16 = New-Object System.Drawing.Size(960,192)
$R4C17 = New-Object System.Drawing.Size(1024,192)

$R4hC1 = New-Object System.Drawing.Size(0,224)
$R4hC2 = New-Object System.Drawing.Size(64,224)
$R4hC3 = New-Object System.Drawing.Size(128,224)
$R4hC4 = New-Object System.Drawing.Size(192,224)
$R4hC5 = New-Object System.Drawing.Size(256,224)
$R4hC6 = New-Object System.Drawing.Size(320,224)
$R4hC7 = New-Object System.Drawing.Size(384,224)
$R4hC8 = New-Object System.Drawing.Size(448,224)
$R4hC9 = New-Object System.Drawing.Size(512,224)
$R4hC10 = New-Object System.Drawing.Size(576,224)
$R4hC11 = New-Object System.Drawing.Size(640,224)
$R4hC12 = New-Object System.Drawing.Size(704,224)
$R4hC13 = New-Object System.Drawing.Size(768,224)
$R4hC14 = New-Object System.Drawing.Size(832,224)
$R4hC15 = New-Object System.Drawing.Size(896,224)
$R4hC16 = New-Object System.Drawing.Size(960,224)
$R4hC17 = New-Object System.Drawing.Size(1024,224)

$R5C1 = New-Object System.Drawing.Size(0,256)
$R5C2 = New-Object System.Drawing.Size(64,256)
$R5C3 = New-Object System.Drawing.Size(128,256)
$R5C4 = New-Object System.Drawing.Size(192,256)
$R5C5 = New-Object System.Drawing.Size(256,256)
$R5C6 = New-Object System.Drawing.Size(320,256)
$R5C7 = New-Object System.Drawing.Size(384,256)
$R5C8 = New-Object System.Drawing.Size(448,256)
$R5C9 = New-Object System.Drawing.Size(512,256)
$R5C10 = New-Object System.Drawing.Size(576,256)
$R5C11 = New-Object System.Drawing.Size(640,256)
$R5C12 = New-Object System.Drawing.Size(704,256)
$R5C13 = New-Object System.Drawing.Size(768,256)
$R5hC14 = New-Object System.Drawing.Size(832,256)
$R5hC15 = New-Object System.Drawing.Size(896,256)
$R5hC16 = New-Object System.Drawing.Size(960,256)
$R5hC17 = New-Object System.Drawing.Size(1024,256)

$R5hC1 = New-Object System.Drawing.Size(0,288)
$R5hC2 = New-Object System.Drawing.Size(64,288)
$R5hC3 = New-Object System.Drawing.Size(128,288)
$R5hC4 = New-Object System.Drawing.Size(192,288)
$R5hC5 = New-Object System.Drawing.Size(256,288)
$R5hC6 = New-Object System.Drawing.Size(320,288)
$R5hC7 = New-Object System.Drawing.Size(384,288)
$R5hC8 = New-Object System.Drawing.Size(448,288)
$R5hC9 = New-Object System.Drawing.Size(512,288)
$R5hC10 = New-Object System.Drawing.Size(576,288)
$R5hC11 = New-Object System.Drawing.Size(640,288)
$R5hC12 = New-Object System.Drawing.Size(704,288)
$R5hC13 = New-Object System.Drawing.Size(768,288)
$R5hC14 = New-Object System.Drawing.Size(832,288)
$R5hC15 = New-Object System.Drawing.Size(896,288)
$R5hC16 = New-Object System.Drawing.Size(960,288)
$R5hC17 = New-Object System.Drawing.Size(1024,288)

$R6C1 = New-Object System.Drawing.Size(0,320)
$R6C2 = New-Object System.Drawing.Size(64,320)
$R6C3 = New-Object System.Drawing.Size(128,320)
$R6C4 = New-Object System.Drawing.Size(192,320)
$R6C5 = New-Object System.Drawing.Size(256,320)
$R6C6 = New-Object System.Drawing.Size(320,320)
$R6C7 = New-Object System.Drawing.Size(384,320)
$R6C8 = New-Object System.Drawing.Size(448,320)
$R6C9 = New-Object System.Drawing.Size(512,320)
$R6C10 = New-Object System.Drawing.Size(576,320)
$R6C11 = New-Object System.Drawing.Size(640,320)
$R6C12 = New-Object System.Drawing.Size(704,320)
$R6C13 = New-Object System.Drawing.Size(768,320)
$R6C14 = New-Object System.Drawing.Size(832,320)
$R6C15 = New-Object System.Drawing.Size(896,320)
$R6C16 = New-Object System.Drawing.Size(960,320)
$R6C17 = New-Object System.Drawing.Size(1024,320)

$R6hC1 = New-Object System.Drawing.Size(0,352)
$R6hC2 = New-Object System.Drawing.Size(64,352)
$R6hC3 = New-Object System.Drawing.Size(128,352)
$R6hC4 = New-Object System.Drawing.Size(192,352)
$R6hC5 = New-Object System.Drawing.Size(256,352)
$R6hC6 = New-Object System.Drawing.Size(320,352)
$R6hC7 = New-Object System.Drawing.Size(384,352)
$R6hC8 = New-Object System.Drawing.Size(448,352)
$R6hC9 = New-Object System.Drawing.Size(512,352)
$R6hC10 = New-Object System.Drawing.Size(576,352)
$R6hC11 = New-Object System.Drawing.Size(640,352)
$R6hC12 = New-Object System.Drawing.Size(704,352)
$R6hC13 = New-Object System.Drawing.Size(768,352)
$R6hC14 = New-Object System.Drawing.Size(832,352)
$R6hC15 = New-Object System.Drawing.Size(896,352)
$R6hC16 = New-Object System.Drawing.Size(960,352)
$R6hC17 = New-Object System.Drawing.Size(1024,352)

$R7C1 = New-Object System.Drawing.Size(0,384)
$R7C2 = New-Object System.Drawing.Size(64,384)
$R7C3 = New-Object System.Drawing.Size(128,384)
$R7C4 = New-Object System.Drawing.Size(192,384)
$R7C5 = New-Object System.Drawing.Size(256,384)
$R7C6 = New-Object System.Drawing.Size(320,384)
$R7C7 = New-Object System.Drawing.Size(384,384)
$R7C8 = New-Object System.Drawing.Size(448,384)
$R7C9 = New-Object System.Drawing.Size(512,384)
$R7C10 = New-Object System.Drawing.Size(576,384)
$R7C11 = New-Object System.Drawing.Size(640,384)
$R7C12 = New-Object System.Drawing.Size(704,384)
$R7C13 = New-Object System.Drawing.Size(768,384)
$R7C14 = New-Object System.Drawing.Size(832,384)
$R7C15 = New-Object System.Drawing.Size(896,384)
$R7C16 = New-Object System.Drawing.Size(960,384)
$R7C17 = New-Object System.Drawing.Size(1024,384)

$R7hC1 = New-Object System.Drawing.Size(0,416)
$R7hC2 = New-Object System.Drawing.Size(64,416)
$R7hC3 = New-Object System.Drawing.Size(128,416)
$R7hC4 = New-Object System.Drawing.Size(192,416)
$R7hC5 = New-Object System.Drawing.Size(256,416)
$R7hC6 = New-Object System.Drawing.Size(320,416)
$R7hC7 = New-Object System.Drawing.Size(384,416)
$R7hC8 = New-Object System.Drawing.Size(448,416)
$R7hC9 = New-Object System.Drawing.Size(512,416)
$R7hC10 = New-Object System.Drawing.Size(576,416)
$R7hC11 = New-Object System.Drawing.Size(640,416)
$R7hC12 = New-Object System.Drawing.Size(704,416)
$R7hC13 = New-Object System.Drawing.Size(768,416)
$R7hC14 = New-Object System.Drawing.Size(832,416)
$R7hC15 = New-Object System.Drawing.Size(896,416)
$R7hC16 = New-Object System.Drawing.Size(960,416)
$R7hC17 = New-Object System.Drawing.Size(1024,416)

$R8C1 = New-Object System.Drawing.Size(0,448)
$R8C2 = New-Object System.Drawing.Size(64,448)
$R8C3 = New-Object System.Drawing.Size(128,448)
$R8C4 = New-Object System.Drawing.Size(192,448)
$R8C5 = New-Object System.Drawing.Size(256,448)
$R8C6 = New-Object System.Drawing.Size(320,448)
$R8C7 = New-Object System.Drawing.Size(384,448)
$R8C8 = New-Object System.Drawing.Size(448,448)
$R8C9 = New-Object System.Drawing.Size(512,448)
$R8C10 = New-Object System.Drawing.Size(576,448)
$R8C11 = New-Object System.Drawing.Size(640,448)
$R8C12 = New-Object System.Drawing.Size(704,448)
$R8C13 = New-Object System.Drawing.Size(768,448)
$R8C14 = New-Object System.Drawing.Size(832,448)
$R8C15 = New-Object System.Drawing.Size(896,448)
$R8C16 = New-Object System.Drawing.Size(960,448)
$R8C17 = New-Object System.Drawing.Size(1024,448)

$R9C1 = New-Object System.Drawing.Size(0,512)
$R9C2 = New-Object System.Drawing.Size(64,512)
$R9C3 = New-Object System.Drawing.Size(128,512)
$R9C4 = New-Object System.Drawing.Size(192,512)
$R9C5 = New-Object System.Drawing.Size(256,512)
$R9C6 = New-Object System.Drawing.Size(320,512)
$R9C7 = New-Object System.Drawing.Size(384,512)
$R9C8 = New-Object System.Drawing.Size(448,512)
$R9C9 = New-Object System.Drawing.Size(512,512)
$R9C10 = New-Object System.Drawing.Size(576,512)
$R9C11 = New-Object System.Drawing.Size(640,512)
$R9C12 = New-Object System.Drawing.Size(704,512)
$R9C13 = New-Object System.Drawing.Size(768,512)
$R9C14 = New-Object System.Drawing.Size(832,512)
$R9C15 = New-Object System.Drawing.Size(896,512)
$R9C16 = New-Object System.Drawing.Size(960,512)
$R9C17 = New-Object System.Drawing.Size(1024,512)

$R9hC1 = New-Object System.Drawing.Size(0,544)
$R9hC2 = New-Object System.Drawing.Size(64,544)
$R9hC3 = New-Object System.Drawing.Size(128,544)
$R9hC4 = New-Object System.Drawing.Size(192,544)
$R9hC5 = New-Object System.Drawing.Size(256,544)
$R9hC6 = New-Object System.Drawing.Size(320,544)
$R9hC7 = New-Object System.Drawing.Size(384,544)
$R9hC8 = New-Object System.Drawing.Size(448,544)
$R9hC9 = New-Object System.Drawing.Size(512,544)
$R9hC10 = New-Object System.Drawing.Size(576,544)
$R9hC11 = New-Object System.Drawing.Size(640,544)
$R9hC12 = New-Object System.Drawing.Size(704,544)
$R9hC13 = New-Object System.Drawing.Size(768,544)
$R9hC14 = New-Object System.Drawing.Size(832,544)
$R9hC15 = New-Object System.Drawing.Size(896,544)
$R9hC16 = New-Object System.Drawing.Size(960,544)
$R9hC17 = New-Object System.Drawing.Size(1024,544)

$R10C1 = New-Object System.Drawing.Size(0,576)
$R10C2 = New-Object System.Drawing.Size(64,576)
$R10C3 = New-Object System.Drawing.Size(128,576)
$R10C4 = New-Object System.Drawing.Size(192,576)
$R10C5 = New-Object System.Drawing.Size(256,576)
$R10C6 = New-Object System.Drawing.Size(320,576)
$R10C7 = New-Object System.Drawing.Size(384,576)
$R10C8 = New-Object System.Drawing.Size(448,576)
$R10C9 = New-Object System.Drawing.Size(512,576)
$R10C10 = New-Object System.Drawing.Size(576,576)
$R10C11 = New-Object System.Drawing.Size(640,576)
$R10C12 = New-Object System.Drawing.Size(704,576)
$R10C13 = New-Object System.Drawing.Size(768,576)
$R10C14 = New-Object System.Drawing.Size(832,576)
$R10C15 = New-Object System.Drawing.Size(896,576)
$R10C16 = New-Object System.Drawing.Size(960,576)
$R10C17 = New-Object System.Drawing.Size(1024,576)

$R10hC1 = New-Object System.Drawing.Size(0,608)
$R10hC2 = New-Object System.Drawing.Size(64,608)
$R10hC3 = New-Object System.Drawing.Size(128,608)
$R10hC4 = New-Object System.Drawing.Size(192,608)
$R10hC5 = New-Object System.Drawing.Size(256,608)
$R10hC6 = New-Object System.Drawing.Size(320,608)
$R10hC7 = New-Object System.Drawing.Size(384,608)
$R10hC8 = New-Object System.Drawing.Size(448,608)
$R10hC9 = New-Object System.Drawing.Size(512,608)
$R10hC10 = New-Object System.Drawing.Size(576,608)
$R10hC11 = New-Object System.Drawing.Size(640,608)
$R10hC12 = New-Object System.Drawing.Size(704,608)
$R10hC13 = New-Object System.Drawing.Size(768,608)
$R10hC14 = New-Object System.Drawing.Size(832,608)
$R10hC15 = New-Object System.Drawing.Size(896,608)
$R10hC16 = New-Object System.Drawing.Size(960,608)
$R10hC17 = New-Object System.Drawing.Size(1024,608)



# Image Locations #
$3DBuilder = [System.Drawing.Image]::FromFile($IconsFolder + "Microsoft.3DBuilder.png")
$ActiproSoftwareLLC_CodeWriter = [System.Drawing.Image]::FromFile($IconsFolder + "ActiproSoftwareLLC.562882FEEB491.png")
$AdobePhotoshopExpress = [System.Drawing.Image]::FromFile($IconsFolder + "AdobeSystemIncorporated.AdobePhotoshop.png")
$AlienwareDigitalDelivery = [System.Drawing.Image]::FromFile($IconsFolder + "DellInc.AlienwareDigitalDelivery.png")
$AutodeskSketchBook = [System.Drawing.Image]::FromFile($IconsFolder + "89006A2E.AutodeskSketchBook.png")
$Asphalt8Airborne = [System.Drawing.Image]::FromFile($IconsFolder + "GAMELOFTSA.Asphalt8Airborne.png")
$Axilesoft_VideoPlayer = [System.Drawing.Image]::FromFile($IconsFolder + "41038Axilesoft.VideoPlayer.png")
$ButtonAppConnector = [System.Drawing.Image]::FromFile($IconsFolder + "Microsoft.AppConnector.png")
$BingFinance = [System.Drawing.Image]::FromFile($IconsFolder + "Microsoft.BingFinance.png")
$BingFoodAndDrink = [System.Drawing.Image]::FromFile($IconsFolder + "Microsoft.BingFoodAndDrink.png")
$BingHealthAndFitness = [System.Drawing.Image]::FromFile($IconsFolder + "Microsoft.BingHealthAndFitness.png")
$BingNews = [System.Drawing.Image]::FromFile($IconsFolder + "Microsoft.BingNews.png")
$BingSports = [System.Drawing.Image]::FromFile($IconsFolder + "Microsoft.BingSports.png")
$BingTranslator = [System.Drawing.Image]::FromFile($IconsFolder + "Microsoft.BingTranslator.png")
$BingTravel = [System.Drawing.Image]::FromFile($IconsFolder + "Microsoft.BingTravel.png")
$BingWeather = [System.Drawing.Image]::FromFile($IconsFolder + "Microsoft.BingWeather.png")
$CaesarsSlotsFreeCasino = [System.Drawing.Image]::FromFile($IconsFolder + "Playtika.CaesarsSlotsFreeCasino.png")
$CandyCrushSaga = [System.Drawing.Image]::FromFile($IconsFolder + "king.com.CandyCrushSaga.png")
$CandyCrushSodaSaga = [System.Drawing.Image]::FromFile($IconsFolder + "king.com.CandyCrushSodaSaga.png")
$Codewriter = [System.Drawing.Image]::FromFile($IconsFolder + "ActiproSoftwareLLC.562882FEEB491.png")
$CyberLinkMediaSuiteEssentials = [System.Drawing.Image]::FromFile($IconsFolder + "DB6EA5DB.CyberLinkMediaSuiteEssentials.png")
$Dayton = [System.Drawing.Image]::FromFile($IconsFolder + "Microsoft.Dayton.png")
$DellSupportAssistforPCs = [System.Drawing.Image]::FromFile($IconsFolder + "DellInc.DellSupportAssistforPCs.png")
$DesktopAppInstaller = [System.Drawing.Image]::FromFile($IconsFolder + "Microsoft.DesktopAppInstaller.png")
$DolbyAccess = [System.Drawing.Image]::FromFile($IconsFolder + "DolbyLaboratories.DolbyAccess.png")
$DrawboardPDF = [System.Drawing.Image]::FromFile($IconsFolder + "Drawboard.DrawboardPDF.png")
$Duolingo = [System.Drawing.Image]::FromFile($IconsFolder + "D5EA27B7.Duolingo.LearnLanguagesforFree.png")
$EclipseManager = [System.Drawing.Image]::FromFile($IconsFolder + "46928bounde.EclipseManager.png")
$Facebook = [System.Drawing.Image]::FromFile($IconsFolder + "Facebook.Facebook.png")
$FarmVille2CountryEscape = [System.Drawing.Image]::FromFile($IconsFolder + "D52A8D61.FarmVille2CountryEscape.png")
$FitbitCoach = [System.Drawing.Image]::FromFile($IconsFolder + "Fitbit.FitbitCoach.png")
$Flipboard = [System.Drawing.Image]::FromFile($IconsFolder + "Flipboard.Flipboard.png")
$FreshPaint = [System.Drawing.Image]::FromFile($IconsFolder + "Microsoft.FreshPaint.png")
$GetHelp = [System.Drawing.Image]::FromFile($IconsFolder + "Microsoft.GetHelp.png")
$GetStarted = [System.Drawing.Image]::FromFile($IconsFolder + "Microsoft.GetStarted.png")
$HPPrinterControl = [System.Drawing.Image]::FromFile($IconsFolder + "AD2F1837.HPPrinterControl.png")
$iHeartRadio = [System.Drawing.Image]::FromFile($IconsFolder + "ClearChannelRadioDigital.iHeartRadio.png")
$Keeper = [System.Drawing.Image]::FromFile($IconsFolder + "KeeperSecurityInc.Keeper.png")
$KYOCERAPrintCenter = [System.Drawing.Image]::FromFile($IconsFolder + "A97ECD55.KYOCERAPrintCenter.png")
$MarchofEmpires = [System.Drawing.Image]::FromFile($IconsFolder + "A278AB0D.MarchofEmpires.png")
$Messaging = [System.Drawing.Image]::FromFile($IconsFolder + "Microsoft.Messaging.png")
$Microsoft3DViewer = [System.Drawing.Image]::FromFile($IconsFolder + "Microsoft.Microsoft3DViewer.png")
$MicrosoftHoloLens = [System.Drawing.Image]::FromFile($IconsFolder + "Microsoft.MicrosoftHoloLens.png")
$MicrosoftJackpot = [System.Drawing.Image]::FromFile($IconsFolder + "30947GamesMore.VegasJackpotSlotsCasino-FreeSlotMac.png")
$MicrosoftJigsaw = [System.Drawing.Image]::FromFile($IconsFolder + "Microsoft.MicrosoftJigsaw.png")
$MicrosoftMahjong = [System.Drawing.Image]::FromFile($IconsFolder + "Microsoft.MicrosoftMahjong.png")
$MovieMoments = [System.Drawing.Image]::FromFile($IconsFolder + "Microsoft.MovieMoments.png")
$MicrosoftOfficeHub = [System.Drawing.Image]::FromFile($IconsFolder + "Microsoft.MicrosoftOfficeHub.png")
$MicrosoftPowerBIForWindows = [System.Drawing.Image]::FromFile($IconsFolder + "Microsoft.MicrosoftPowerBIForWindows.png")
$MicrosoftPowerBIDesktop = [System.Drawing.Image]::FromFile($IconsFolder + "Microsoft.MicrosoftPowerBIDesktop.png")
$MicrosoftSkyDrive = [System.Drawing.Image]::FromFile($IconsFolder + "Microsoft.MicrosoftSkyDrive.png")
$MicrosoftSolitaireCollection = [System.Drawing.Image]::FromFile($IconsFolder + "Microsoft.MicrosoftSolitaireCollection.png")
$MicrosoftStickyNotes = [System.Drawing.Image]::FromFile($IconsFolder + "Microsoft.MicrosoftStickyNotes.png")
$MicrosoftSudoku = [System.Drawing.Image]::FromFile($IconsFolder + "Microsoft.MicrosoftSudoku.png")
$MinecraftUWP = [System.Drawing.Image]::FromFile($IconsFolder + "Microsoft.MinecraftUWP.png")
$MixedRealityPortal = [System.Drawing.Image]::FromFile($IconsFolder + "Microsoft.MixedReality.Portal.png")
$MSPaint = [System.Drawing.Image]::FromFile($IconsFolder + "Microsoft.MSPaint.png")
$Netflix = [System.Drawing.Image]::FromFile($IconsFolder + "4DF9E0F8.Netflix.png")
$NetworkSpeedTest = [System.Drawing.Image]::FromFile($IconsFolder + "Microsoft.NetworkSpeedTest.png")
$NYTCrossword = [System.Drawing.Image]::FromFile($IconsFolder + "TheNewYorkTimes.NYTCrossword.png")
$OfficeOneNote = [System.Drawing.Image]::FromFile($IconsFolder + "Microsoft.Office.OneNote.png")
$OfficeSway = [System.Drawing.Image]::FromFile($IconsFolder + "Microsoft.Office.Sway.png")
$OneConnect = [System.Drawing.Image]::FromFile($IconsFolder + "Microsoft.OneConnect.png")
$PandoraMediaInc_Pandora = [System.Drawing.Image]::FromFile($IconsFolder + "PandoraMediaInc.29680B314EFC2.png")
$ParadiseBay = [System.Drawing.Image]::FromFile($IconsFolder + "king.com.ParadiseBay.png")
$People = [System.Drawing.Image]::FromFile($IconsFolder + "Microsoft.People.png")
$PhototasticCollage = [System.Drawing.Image]::FromFile($IconsFolder + "ThumbmunkeysLtd.PhototasticCollage.png")
$Plex = [System.Drawing.Image]::FromFile($IconsFolder + "CAF9E577.Plex.png")
$PicsArtPhotoStudio = [System.Drawing.Image]::FromFile($IconsFolder + "2FE3CB00.PicsArt-PhotoStudio.png")
$PowerBi = [System.Drawing.Image]::FromFile($IconsFolder + "Microsoft.PowerBi.png")
$Print3D = [System.Drawing.Image]::FromFile($IconsFolder + "Microsoft.Print3D.png")
$RemoteDesktop = [System.Drawing.Image]::FromFile($IconsFolder + "Microsoft.RemoteDesktop.png")
$RoyalRevolt2 = [System.Drawing.Image]::FromFile($IconsFolder + "flaregamesGmbH.RoyalRevolt2.png")
$ScreenSketch = [System.Drawing.Image]::FromFile($IconsFolder + "Microsoft.ScreenSketch.png")
$SeaofThieves = [System.Drawing.Image]::FromFile($IconsFolder + "Microsoft.SeaofThieves.png")
$Shazam = [System.Drawing.Image]::FromFile($IconsFolder + "ShazamEntertainmentLtd.Shazam.png")
$SkypeWiFi = [System.Drawing.Image]::FromFile($IconsFolder + "Microsoft.SkypeWiFi.png")
$SlingTV = [System.Drawing.Image]::FromFile($IconsFolder + "SlingTVLLC.SlingTV.png")
$SpartaUWP = [System.Drawing.Image]::FromFile($IconsFolder + "Microsoft.SpartaUWP.png")
$StorePurchaseApp = [System.Drawing.Image]::FromFile($IconsFolder + "Microsoft.StorePurchaseApp.png")
$StudiosWordament = [System.Drawing.Image]::FromFile($IconsFolder + "Microsoft.Studios.Wordament.png")
$SurfaceHub = [System.Drawing.Image]::FromFile($IconsFolder + "Microsoft.SurfaceHub.png")
$SkypeApp = [System.Drawing.Image]::FromFile($IconsFolder + "Microsoft.SkypeApp.png")
$Taptiles = [System.Drawing.Image]::FromFile($IconsFolder + "Microsoft.Taptiles.png")
$TuneInRadio = [System.Drawing.Image]::FromFile($IconsFolder + "TuneIn.TuneInRadio.png")
$Todos = [System.Drawing.Image]::FromFile($IconsFolder + "Microsoft.Todos.png")
$Twitter = [System.Drawing.Image]::FromFile($IconsFolder + "9E2F88E3.Twitter.png")
$VegasJackpotSlotsCasinoFreeSlotMac = [System.Drawing.Image]::FromFile($IconsFolder + "30947GamesMore.VegasJackpotSlotsCasino-FreeSlotMac.png")
$Wallet = [System.Drawing.Image]::FromFile($IconsFolder + "Microsoft.Wallet.png")
$Whiteboard = [System.Drawing.Image]::FromFile($IconsFolder + "Microsoft.Whiteboard.png")
$WindowsAlarm = [System.Drawing.Image]::FromFile($IconsFolder + "Microsoft.WindowsAlarms.png")
$WindowsCalculator = [System.Drawing.Image]::FromFile($IconsFolder + "Microsoft.WindowsCalculator.png")
$WindowsCamera = [System.Drawing.Image]::FromFile($IconsFolder + "Microsoft.WindowsCamera.png")
$WindowsCommunicationsApps = [System.Drawing.Image]::FromFile($IconsFolder + "Microsoft.WindowsCommunicationsApps.png")
$WindowsCommunicationsApps_Calendar = [System.Drawing.Image]::FromFile($IconsFolder + "Microsoft.WindowsCommunicationsApps_Calendar.png")
$WindowsCommunicationsApps_Mail = [System.Drawing.Image]::FromFile($IconsFolder + "Microsoft.WindowsCommunicationsApps_Mail.png")
$WindowsFeedbackHub = [System.Drawing.Image]::FromFile($IconsFolder + "Microsoft.WindowsFeedbackHub.png")
$WindowsMaps = [System.Drawing.Image]::FromFile($IconsFolder + "Microsoft.WindowsMaps.png")
$WindowsPhotos = [System.Drawing.Image]::FromFile($IconsFolder + "Microsoft.Windows.Photos.png")
$WindowsReadingList = [System.Drawing.Image]::FromFile($IconsFolder + "Microsoft.WindowsReadingList.png")
$WindowsScan = [System.Drawing.Image]::FromFile($IconsFolder + "Microsoft.WindowsScan.png")
$WindowsSoundRecorder = [System.Drawing.Image]::FromFile($IconsFolder + "Microsoft.WindowsSoundRecorder.png")
$WindowsStore = [System.Drawing.Image]::FromFile($IconsFolder + "Microsoft.WindowsStore.png")
$Wordament = [System.Drawing.Image]::FromFile($IconsFolder + "Microsoft.Studios.Wordament.png")
$Wunderlist = [System.Drawing.Image]::FromFile($IconsFolder + "6Wunderkinder.Wunderlist.png")
$XboxApp = [System.Drawing.Image]::FromFile($IconsFolder + "Microsoft.XboxApp.png")
$XboxCompanion = [System.Drawing.Image]::FromFile($IconsFolder + "Microsoft.XboxCompanion.png")
$XboxGameOverlay = [System.Drawing.Image]::FromFile($IconsFolder + "Microsoft.XboxGameOverlay.png")
$XboxOneSmartGlass = [System.Drawing.Image]::FromFile($IconsFolder + "Microsoft.XboxOneSmartGlass.png")
$YourPhone = [System.Drawing.Image]::FromFile($IconsFolder + "Microsoft.YourPhone.png")
$ZuneMusic = [System.Drawing.Image]::FromFile($IconsFolder + "Microsoft.ZuneMusic.png")
$ZuneVideo = [System.Drawing.Image]::FromFile($IconsFolder + "Microsoft.ZuneVideo.png")

$HEIFImageExtension = [System.Drawing.Image]::FromFile($IconsFolder + "Microsoft.HEIFImageExtension.png")
$HEVCVideoExtension = [System.Drawing.Image]::FromFile($IconsFolder + "Microsoft.HEVCVideoExtension.png")
$MPEG2VideoExtension = [System.Drawing.Image]::FromFile($IconsFolder + "Microsoft.MPEG2VideoExtension.png")
$VP9VideoExtensions = [System.Drawing.Image]::FromFile($IconsFolder + "Microsoft.VP9VideoExtensions.png")
$WebMediaExtensions = [System.Drawing.Image]::FromFile($IconsFolder + "Microsoft.WebMediaExtensions.png")
$WebpImageExtension = [System.Drawing.Image]::FromFile($IconsFolder + "Microsoft.WebpImageExtension.png")

$QuickAssist = [System.Drawing.Image]::FromFile($IconsFolder + "App.Support.QuickAssist.png")

$DefaultImage = [System.Drawing.Image]::FromFile($IconsFolder + "default.png")
$ExtensionsImage = [System.Drawing.Image]::FromFile($IconsFolder + "plugin.png")



# Form  Object #
$DefaultForm = New-Object System.Windows.Forms.Form
# Window Border #
$DefaultForm.FormBorderStyle = $BorderFixedSimple
# Window Position #
$DefaultForm.StartPosition = "CenterScreen"
# Window State #
$DefaultForm.WindowState = "Normal"
# Window Position #
$DefaultForm.Topmost = $True
# Window Position Not Eternal #
$DefaultForm.Topmost = $False
# Window Size #
$DefaultForm.Size = New-Object System.Drawing.Size(592,680)
# Window Title #
$DefaultForm.Text = "Windows 10 Metro App & Feature on Demand Manager - By MarioMasta64 - Made With Love `<3"
# Window Icon #
$DefaultForm.Icon = $WSResetIcon
# Window Disable Closing Window #
$DefaultForm.Add_FormClosing({$_.Cancel=$True})
# Window Disable Minimize Window #
$DefaultForm.MinimizeBox = $False
# Window Disable Maximize Window #
$DefaultForm.MaximizeBox = $False
# Window Disable Resizing Window #
$DefaultForm.SizeGripStyle = "Hide"



$PanelApp = New-Object System.Windows.Forms.Panel
$PanelApp.Location = $R1C1
$PanelApp.Size = $R6C10
$DefaultForm.Controls.Add($PanelApp)

$PanelExtension = New-Object System.Windows.Forms.Panel
$PanelExtension.Location = $R1C1
$PanelExtension.Size = $R6C10
$DefaultForm.Controls.Add($PanelExtension)

$PanelBloatware = New-Object System.Windows.Forms.Panel
$PanelBloatware.Location = $R1C1
$PanelBloatware.Size = $R6C10
$DefaultForm.Controls.Add($PanelBloatware)

$PanelExtra = New-Object System.Windows.Forms.Panel
$PanelExtra.Location = $R1C1
$PanelExtra.Size = $R6C10
$DefaultForm.Controls.Add($PanelExtra)

$PanelFeature = New-Object System.Windows.Forms.Panel
$PanelFeature.Location = $R1C1
$PanelFeature.Size = $R6C10
$DefaultForm.Controls.Add($PanelFeature)

$PanelOptions = New-Object System.Windows.Forms.Panel
$PanelOptions.Location = $R6C1
$PanelOptions.Size = $R2C10
$DefaultForm.Controls.Add($PanelOptions)

$PanelApp.Visible = $True
$PanelExtension.Visible = $False
$PanelBloatware.Visible = $False
$PanelExtra.Visible = $False
$PanelFeature.Visible = $False
$PanelOptions.Visible = $True



Function Redraw {

	CheckInstalledApps
	DrawOptions
	
	DrawApps
	DrawExtensions
	DrawBloatwares
	DrawExtras
	DrawFeatures
	
	ChangeMode
	DrawNotificationTray
	
	$Global:Action = "AllUser"; ChangeAction
	
	Return
	
}

# Add Options Info Stuff ??? #	

$Global:NoteApp = "These Are Apps That Are Typically Built-In To Windows"
$Global:NoteExtension = "These Are Extensions For Windows To Read Different Files`r`nAdvertising Is Here Because It Sorta Fits As An Extension?"
$Global:NoteBloatware = "These Are Apps That Are Not Part Of Your System [Microsoft]"
$Global:NoteExtra = "These Are Apps That Are Not Part Of Your System [Third-Party]"
$Global:NoteFeature = "This Is Currently Broken`r`nNothing To Do Here"

$Global:NoteCurrentUser = "Toggles App For Current User"
$Global:NoteNewUser = "Toggles App For New Users [Upgrades Too]"
$Global:NoteAllUser = "UNINSTALLS APP FOR ALL USERS`r`nWARNING WARNING WARNING WARNING WARNING WARNING WARNING WARNING WARNING WARNING`r`nPERMANENT PERMANENT PERMANENT PERMANENT PERMANENT PERMANENT PERMANENT PERMANENT"



Function ChangeMode {
	$Panel = Get-Variable -Name "Panel$Mode" -Value; $Panel.Visible = $False;
	Switch ("$Mode") {
		"App" { $Global:Mode = "Extension"; Break; };
		"Extension" { $Global:Mode = "Bloatware"; Break; };
		"Bloatware" { $Global:Mode = "Extra"; };
		"Extra" { $Global:Mode = "Feature"; Break; };
		"Feature" { $Global:Mode = "App"; Break; };
	};
	$Panel = Get-Variable -Name "Panel$Mode" -Value; $Panel.Visible = $True;
	$Note = Get-Variable -Name "Note$Mode" -Value; OutputText -Message "`r`nMode Changed To $Mode`r`n$Note`r`n";
	Return;
};



Function ChangeAction {
	Switch ("$Action") {
		"CurrentUser" { $Global:Action = "NewUser"; Break; };
		"NewUser" { $Global:Action = "CurrentUser"; Break; };
		"AllUser" { $Global:Action = "CurrentUser"; Break; };
	};
	$Note = Get-Variable -Name "Note$Action" -Value; OutputText -Message "`r`nAction Changed To $Action`r`n$Note`r`n";
	Return;
};



# TextBox Object #
$DefaultTextBox = New-Object System.Windows.Forms.TextBox
# TextBox Position #
$DefaultTextBox.Location = $R7C1
# TextBox Size #
$DefaultTextBox.Size = $R5C10
# TextBox Font #
$DefaultTextBox.Font = New-Object System.Drawing.Font("Consolas", 8 ,[System.Drawing.FontStyle]::Regular)
# TextBox Allow Multiple Lines #
$DefaultTextBox.MultiLine = $True
# TextBox Show Vertical Scroll Bars #
$DefaultTextBox.ScrollBars = "Vertical"
# TextBox Set Read Only #
$DefaultTextBox.ReadOnly = $True
# TextBox Hide Selection #
$DefaultTextBox.HideSelection = $False
# TextBox Render #
$DefaultForm.Controls.Add($DefaultTextBox)



Function DrawApps {
	$Global:Mode = "App"
	$App1 = @{ Location = $R1C1; Size = $R2C2; Image = $3DBuilder; Pattern = "3DBuilder"; Name = "3D Builder"; }; DrawAppButton "App1"
	$App2 = @{ Location = $R1C2; Size = $R2C2; Image = $WindowsAlarm; Pattern = "Alarm"; Name = "Alarms && Clock"; }; DrawAppButton "App2"
	$App3 = @{ Location = $R1C3; Size = $R2C2; Image = $DefaultImage; Pattern = "AppConnector"; Name = "App Connector"; }; DrawAppButton "App3"
	$App4 = @{ Location = $R1C4; Size = $R2C2; Image = $DesktopAppInstaller; Pattern = "AppInstaller"; Name = "App Installer"; }; DrawAppButton "App4"
	$App5 = @{ Location = $R1C5; Size = $R2C3; Image = $WindowsCommunicationsApps; Pattern = "CommunicationsApps"; Name = "Calendar and Mail"; }; DrawAppButton "App5"
	# $App6 = @{ Location = $R1C6; Size = $R2C2; Image = $DefaultImage; Pattern = ""; Name = ""; }; DrawAppButton "App6"
	$App7 = @{ Location = $R1C7; Size = $R2C2; Image = $WindowsCalculator; Pattern = "Calculator"; Name = "Calculator"; }; DrawAppButton "App7"
	$App8 = @{ Location = $R1C8; Size = $R2C2; Image = $WindowsCamera; Pattern = "Camera"; Name = "Camera"; }; DrawAppButton "App8"
	$App9 = @{ Location = $R1C9; Size = $R2C2; Image = $WindowsFeedbackHub; Pattern = "Feedback"; Name = "Feedback Hub"; }; DrawAppButton "App9"
	$App10 = @{ Location = $R2C1; Size = $R2C2; Image = $GetHelp; Pattern = "GetHelp"; Name = "Get Help"; }; DrawAppButton "App10"
	$App11 = @{ Location = $R2C2; Size = $R2C2; Image = $MicrosoftOfficeHub; Pattern = "OfficeHub"; Name = "Office"; }; DrawAppButton "App11"
	$App12 = @{ Location = $R2C3; Size = $R2C2; Image = $GetStarted; Pattern = "GetStarted"; Name = "Get Started"; }; DrawAppButton "App12"
	$App13 = @{ Location = $R2C4; Size = $R2C2; Image = $SkypeApp; Pattern = "SkypeApp"; Name = "Get Skype"; }; DrawAppButton "App13"
	$App14 = @{ Location = $R2C5; Size = $R2C2; Image = $ZuneMusic; Pattern = "ZuneMusic"; Name = "Groove Music"; }; DrawAppButton "App14"
	$App15 = @{ Location = $R2C6; Size = $R2C2; Image = $WindowsMaps; Pattern = "Maps"; Name = "Maps"; }; DrawAppButton "App15"
	$App16 = @{ Location = $R2C7; Size = $R2C2; Image = $Messaging; Pattern = "Messaging"; Name = "Messaging and Skype Video"; }; DrawAppButton "App16"
	$App17 = @{ Location = $R2C8; Size = $R2C2; Image = $MicrosoftSolitaireCollection; Pattern = "SolitaireCollection"; Name = "Microsoft Solitaire Collection"; }; DrawAppButton "App17"
	$App18 = @{ Location = $R2C9; Size = $R2C2; Image = $Wallet; Pattern = "Wallet"; Name = "Microsoft Wallet"; }; DrawAppButton "App18"
	$App19 = @{ Location = $R3C1; Size = $R2C2; Image = $DefaultImage; Pattern = "ConnectivityStore"; Name = "Microsoft Wi-Fi"; }; DrawAppButton "App19"
	$App20 = @{ Location = $R3C2; Size = $R2C2; Image = $MixedRealityPortal; Pattern = "MixedReality"; Name = "Mixed Reality"; }; DrawAppButton "App20"
	$App21 = @{ Location = $R3C3; Size = $R2C2; Image = $ZuneVideo; Pattern = "ZuneVideo"; Name = "Movies && TV"; }; DrawAppButton "App21"
	$App22 = @{ Location = $R3C4; Size = $R2C2; Image = $OfficeOneNote; Pattern = "OneNote"; Name = "OneNote"; }; DrawAppButton "App22"
	$App23 = @{ Location = $R3C5; Size = $R2C2; Image = $OneConnect; Pattern = "OneConnect"; Name = "Paid Wi-Fi && Cellular"; }; DrawAppButton "App23"
	$App24 = @{ Location = $R3C6; Size = $R2C2; Image = $MSPaint; Pattern = "MSPaint"; Name = "Paint 3D"; }; DrawAppButton "App24"
	$App25 = @{ Location = $R3C7; Size = $R2C2; Image = $People; Pattern = "Microsoft.People"; Name = "People"; }; DrawAppButton "App25"
	$App26 = @{ Location = $R3C8; Size = $R2C2; Image = $DefaultImage; Pattern = "CommsPhone"; Name = "Phone"; }; DrawAppButton "App26"
	$App27 = @{ Location = $R3C9; Size = $R2C2; Image = $WindowsPhone; Pattern = "WindowsPhone"; Name = "Phone Companion"; }; DrawAppButton "App27"
	$App28 = @{ Location = $R4C1; Size = $R2C3; Image = $YourPhone; Pattern = "YourPhone"; Name = "Your Phone"; }; DrawAppButton "App28"
	# $App29 = @{ Location = $R4C2; Size = $R2C2; Image = $DefaultImage; Pattern = ""; Name = ""; }; DrawAppButton "App29"
	$App30 = @{ Location = $R4C3; Size = $R2C3; Image = $WindowsPhotos; Pattern = "Photos"; Name = "Photos and Video Editor"; }; DrawAppButton "App30"
	# $App31 = @{ Location = $R4C4; Size = $R2C2; Image = $DefaultImage; Pattern = ""; Name = ""; }; DrawAppButton "App31"
	$App32 = @{ Location = $R4C5; Size = $R2C2; Image = $ScreenSketch; Pattern = "ScreenSketch"; Name = "Snip && Sketch"; }; DrawAppButton "App32"
	$App33 = @{ Location = $R4C6; Size = $R2C2; Image = $MicrosoftStickyNotes; Pattern = "StickyNotes"; Name = "Sticky Notes"; }; DrawAppButton "App33"
	$App34 = @{ Location = $R4C7; Size = $R2C2; Image = $Microsoft3DViewer; Pattern = "3DViewer"; Name = "3D Viewer"; }; DrawAppButton "App34"
	$App35 = @{ Location = $R4C8; Size = $R2C2; Image = $Print3D; Pattern = "Print3D"; Name = "Print 3D"; }; DrawAppButton "App35"
	$App36 = @{ Location = $R4C9; Size = $R2C2; Image = $WindowsSoundRecorder; Pattern = "SoundRecorder"; Name = "Voice Recorder"; }; DrawAppButton "App36"
	$App37 = @{ Location = $R5C1; Size = $R2C2; Image = $BingWeather; Pattern = "BingWeather"; Name = "Weather"; }; DrawAppButton "App37"
	$App38 = @{ Location = $R5C2; Size = $R2C3; Image = $XboxApp; Pattern = "XboxApp"; Name = "Xbox Console Companion"; }; DrawAppButton "App38"
	# $App39 = @{ Location = $R5C3; Size = $R2C2; Image = $DefaultImage; Pattern = ""; Name = ""; }; DrawAppButton "App39"
	$App40 = @{ Location = $R5C4; Size = $R2C2; Image = $XboxGameOverlay; Pattern = "Overlay"; Name = "Xbox Game Overlay"; }; DrawAppButton "App40"
	$App41 = @{ Location = $R5C5; Size = $R2C2; Image = $WindowsStore; Pattern = "WindowsStore"; Name = "Windows Store"; }; DrawAppButton "App41"
	Return
}

Function DrawExtensions {
	$Global:Mode = "Extension"
	$Extension1 = @{ Location = $R1C1; Size = $R2C2; Image = "none"; Pattern = "AV1VideoExtension"; Name = "AV1 Video"; }; DrawAppButton "Extension1"
	$Extension2 = @{ Location = $R1C2; Size = $R2C2; Image = "none"; Pattern = "HEIFImageExtension"; Name = "HEIF Image"; }; DrawAppButton "Extension2"
	$Extension3 = @{ Location = $R1C3; Size = $R2C2; Image = "none"; Pattern = "HEVCVideoExtension"; Name = "HVEC Video"; }; DrawAppButton "Extension3"
	$Extension4 = @{ Location = $R1C4; Size = $R2C2; Image = "none"; Pattern = "MPEG2VideoExtension"; Name = "MPEG-2 Video"; }; DrawAppButton "Extension4"
	$Extension5 = @{ Location = $R1C5; Size = $R2C2; Image = "none"; Pattern = "RawImageExtension"; Name = "Raw Image"; }; DrawAppButton "Extension5"
	$Extension6 = @{ Location = $R1C6; Size = $R2C2; Image = "none"; Pattern = "VP9VideoExtensions"; Name = "VP9 Video"; }; DrawAppButton "Extension6"
	$Extension7 = @{ Location = $R1C7; Size = $R2C2; Image = "none"; Pattern = "WebMediaExtensions"; Name = "Web Media"; }; DrawAppButton "Extension7"
	$Extension8 = @{ Location = $R1C8; Size = $R2C2; Image = "none"; Pattern = "WebpImageExtension"; Name = "WebP Image"; }; DrawAppButton "Extension8"
	$Extension9 = @{ Location = $R1C9; Size = $R2C2; Image = "none"; Pattern = "Advertising"; Name = "Advertising"; }; DrawAppButton "Extension9"
	Return
}

Function DrawBloatwares {
	$Global:Mode = "Bloatware"
	$Bloatware1 = @{ Location = $R1C1; Size = $R2C2; Image = $BingNews; Pattern = "Microsoft.BingNews"; Name = "Microsoft News"; }; DrawAppButton "Bloatware1"
	$Bloatware2 = @{ Location = $R1C2; Size = $R2C2; Image = $OfficeSway; Pattern = "Microsoft.Office.Sway"; Name = "Sway"; }; DrawAppButton "Bloatware2"
	$Bloatware3 = @{ Location = $R1C3; Size = $R2C2; Image = $RemoteDesktop; Pattern = "Microsoft.RemoteDesktop"; Name = "Remote Desktop"; }; DrawAppButton "Bloatware3"
	$Bloatware4 = @{ Location = $R1C4; Size = $R2C2; Image = $XboxOneSmartGlass; Pattern = "XboxOneSmartGlass"; Name = "Xbox One SmartGlass"; }; DrawAppButton "Bloatware4"
	$Bloatware5 = @{ Location = $R1C5; Size = $R2C2; Image = $BingFinance; Pattern = "Microsoft.BingFinance"; Name = "MSN Money"; }; DrawAppButton "Bloatware5"
	$Bloatware6 = @{ Location = $R1C6; Size = $R2C2; Image = $BingSports; Pattern = "Microsoft.BingSports"; Name = "MSN Sports"; }; DrawAppButton "Bloatware6"
	$Bloatware7 = @{ Location = $R1C7; Size = $R2C2; Image = $MicrosoftHoloLens; Pattern = "Microsoft.MicrosoftHoloLens"; Name = "Microsoft HoloLens"; }; DrawAppButton "Bloatware7"
	$Bloatware8 = @{ Location = $R1C8; Size = $R2C2; Image = $MicrosoftSkyDrive; Pattern = "Microsoft.MicrosoftSkyDrive"; Name = "OneDrive"; }; DrawAppButton "Bloatware8"
	$Bloatware9 = @{ Location = $R1C9; Size = $R2C2; Image = $Todos; Pattern = "Microsoft.Todos"; Name = "Microsoft To-Do"; }; DrawAppButton "Bloatware9"
	$Bloatware10 = @{ Location = $R2C1; Size = $R2C2; Image = $Whiteboard; Pattern = "Microsoft.Whiteboard"; Name = "Microsoft Whiteboard"; }; DrawAppButton "Bloatware10"
	$Bloatware11 = @{ Location = $R2C2; Size = $R2C2; Image = $WindowsScan; Pattern = "Microsoft.WindowsScan"; Name = "Scan"; }; DrawAppButton "Bloatware11"
	$Bloatware12 = @{ Location = $R2C3; Size = $R2C2; Image = $MinecraftUWP; Pattern = "Microsoft.MinecraftUWP"; Name = "Minecraft"; }; DrawAppButton "Bloatware12"
	$Bloatware13 = @{ Location = $R2C4; Size = $R2C2; Image = $SurfaceHub; Pattern = "Microsoft.SurfaceHub"; Name = "Surface"; }; DrawAppButton "Bloatware13"
	$Bloatware14 = @{ Location = $R2C5; Size = $R2C2; Image = $FreshPaint; Pattern = "Microsoft.FreshPaint"; Name = "Fresh Paint"; }; DrawAppButton "Bloatware14"
	$Bloatware15 = @{ Location = $R2C6; Size = $R2C2; Image = $BingTranslator; Pattern = "Microsoft.BingTranslator"; Name = "BingTranslator"; }; DrawAppButton "Bloatware15"
	$Bloatware16 = @{ Location = $R2C7; Size = $R2C2; Image = $MicrosoftPowerBIForWindows; Pattern = "Microsoft.MicrosoftPowerBIForWindows"; Name = "Power BI Mobile"; }; DrawAppButton "Bloatware16"
	$Bloatware17 = @{ Location = $R2C8; Size = $R2C2; Image = $MicrosoftPowerBIDesktop; Pattern = "Microsoft.MicrosoftPowerBIDesktop"; Name = "Power BI Desktop"; }; DrawAppButton "Bloatware17"
	$Bloatware18 = @{ Location = $R2C9; Size = $R2C2; Image = $Codewriter; Pattern = "Microsoft.Codewriter"; Name = "Code Writer"; }; DrawAppButton "Bloatware18"
	$Bloatware19 = @{ Location = $R3C1; Size = $R2C2; Image = $MicrosoftJigsaw; Pattern = "Microsoft.MicrosoftJigsaw"; Name = "Microsoft Jigsaw"; }; DrawAppButton "Bloatware19"
	$Bloatware20 = @{ Location = $R3C2; Size = $R2C2; Image = $MicrosoftMahjong; Pattern = "Microsoft.MicrosoftMahjong"; Name = "Microsoft Mahjong"; }; DrawAppButton "Bloatware20"
	$Bloatware21 = @{ Location = $R3C3; Size = $R2C2; Image = $MicrosoftSudoku; Pattern = "Microsoft.MicrosoftSudoku"; Name = "Microsoft Sudoku"; }; DrawAppButton "Bloatware21"
	$Bloatware22 = @{ Location = $R3C4; Size = $R2C2; Image = $Wordament; Pattern = "Microsoft.Studios.Wordament"; Name = "Microsoft Ultimate Word Games"; }; DrawAppButton "Bloatware22"
	$Bloatware23 = @{ Location = $R3C5; Size = $R2C2; Image = $Taptiles; Pattern = "Microsoft.Taptiles"; Name = "Taptiles"; }; DrawAppButton "Bloatware23"
	$Bloatware24 = @{ Location = $R3C6; Size = $R2C2; Image = $XboxCompanion; Pattern = "Microsoft.XboxCompanion"; Name = "Xbox 360 SmartGlass"; }; DrawAppButton "Bloatware24"
	$Bloatware25 = @{ Location = $R3C7; Size = $R2C2; Image = $MicrosoftJackpot; Pattern = "Microsoft.MicrosoftJackpot"; Name = "Microsoft Jackpot"; }; DrawAppButton "Bloatware25"
	Return
}

Function DrawExtras {
	$Global:Mode = "Extra"
	$Extra1 = @{ Location = $R1C1; Size = $R2C2; Image = $Duolingo; Pattern = "D5EA27B7.Duolingo-LearnLanguagesforFree"; Name = "Duolingo"; }; DrawAppButton "Extra1"
	$Extra2 = @{ Location = $R1C2; Size = $R2C2; Image = $EclipseManager; Pattern = "46928bounde.EclipseManager"; Name = "Eclipse Manager"; }; DrawAppButton "Extra2"
	$Extra3 = @{ Location = $R1C3; Size = $R2C2; Image = $ActiproSoftwareLLC_CodeWriter; Pattern = "ActiproSoftwareLLC.562882FEEB491"; Name = "Code Writer"; }; DrawAppButton "Extra3"
	$Extra4 = @{ Location = $R1C4; Size = $R2C2; Image = $NetworkSpeedTest; Pattern = "Microsoft.NetworkSpeedTest"; Name = "Network Speed Test"; }; DrawAppButton "Extra4"
	$Extra5 = @{ Location = $R1C5; Size = $R2C2; Image = $PandoraMediaInc_Pandora; Pattern = "PandoraMediaInc.29680B314EFC2"; Name = "Pandora"; }; DrawAppButton "Extra5"
	$Extra6 = @{ Location = $R1C6; Size = $R2C2; Image = $PhototasticCollage; Pattern = "PhototasticCollage"; Name = "Phototastic Collage"; }; DrawAppButton "Extra6"
	$Extra7 = @{ Location = $R1C7; Size = $R2C2; Image = $Axilesoft_VideoPlayer; Pattern = "41038AXILESOFT.ACGMEDIAPLAYER"; Name = "ACG Player"; }; DrawAppButton "Extra7"
	$Extra8 = @{ Location = $R1C8; Size = $R2C2; Image = $CandyCrushSaga; Pattern = "king.com.CandyCrushSaga"; Name = "Candy Crush Saga"; }; DrawAppButton "Extra8"
	$Extra9 = @{ Location = $R1C9; Size = $R2C2; Image = $DolbyAccess; Pattern = "DolbyLaboratories.DolbyAccess"; Name = "Dolby Access"; }; DrawAppButton "Extra9"
	$Extra10 = @{ Location = $R2C1; Size = $R2C2; Image = $FitbitCoach; Pattern = "Fitbit.FitbitCoach"; Name = "Fitbit Coach"; }; DrawAppButton "Extra10"
	$Extra11 = @{ Location = $R2C2; Size = $R2C2; Image = $DellSupportAssistforPCs; Pattern = "DellInc.DellSupportAssistforPCs"; Name = "Dell SupportAssist for PCs"; }; DrawAppButton "Extra11"
	$Extra12 = @{ Location = $R2C3; Size = $R2C2; Image = $AlienwareDigitalDelivery; Pattern = "DellInc.AlienwareDigitalDelivery"; Name = "Alienware Digital Delivery"; }; DrawAppButton "Extra12"
	$Extra13 = @{ Location = $R2C4; Size = $R2C2; Image = $AdobePhotoshopExpress; Pattern = "AdobeSystemsIncorporated.AdobePhotoshopExpress"; Name = "Photoshop Express"; }; DrawAppButton "Extra13"
	$Extra14 = @{ Location = $R2C5; Size = $R2C2; Image = $Plex; Pattern = "CAF9E577.Plex"; Name = "Plex"; }; DrawAppButton "Extra14"
	$Extra15 = @{ Location = $R2C6; Size = $R2C2; Image = $Flipboard; Pattern = "Flipboard.Flipboard"; Name = "Flipboard"; }; DrawAppButton "Extra15"
	$Extra16 = @{ Location = $R2C7; Size = $R2C2; Image = $KYOCERAPrintCenter; Pattern = "A97ECD55.KYOCERAPrintCenter"; Name = "Kyocera Print Center"; }; DrawAppButton "Extra16"
	$Extra17 = @{ Location = $R2C8; Size = $R2C2; Image = $DrawboardPDF; Pattern = "Drawboard.DrawboardPDF"; Name = "Drawboard PDF"; }; DrawAppButton "Extra17"
	$Extra18 = @{ Location = $R2C9; Size = $R2C2; Image = $CandyCrushSodaSaga; Pattern = "king.com.CandyCrushSodaSaga"; Name = "Candy Crush Soda Saga"; }; DrawAppButton "Extra18"
	$Extra19 = @{ Location = $R3C1; Size = $R2C2; Image = $Facebook; Pattern = "Facebook.Facebook"; Name = "Facebook"; }; DrawAppButton "Extra19"
	$Extra20 = @{ Location = $R3C2; Size = $R2C2; Image = $Netflix; Pattern = "4DF9E0F8.Netflix"; Name = "Netflix"; }; DrawAppButton "Extra20"
	$Extra21 = @{ Location = $R3C3; Size = $R2C2; Image = $AutodeskSketchBook; Pattern = "89006A2E.AutodeskSketchBook"; Name = "SketchBook"; }; DrawAppButton "Extra21"
	$Extra22 = @{ Location = $R3C4; Size = $R2C2; Image = $Asphalt8Airborne; Pattern = "GAMELOFTSA.Asphalt8Airborne"; Name = "Asphalt 8: Airborne"; }; DrawAppButton "Extra22"
	$Extra23 = @{ Location = $R3C5; Size = $R2C2; Image = $iHeartRadio; Pattern = "ClearChannelRadioDigital.iHeartRadio"; Name = "iHeartRadio"; }; DrawAppButton "Extra23"
	$Extra24 = @{ Location = $R3C6; Size = $R2C2; Image = $Twitter; Pattern = "9E2F88E3.Twitter"; Name = "Twitter"; }; DrawAppButton "Extra24"
	$Extra25 = @{ Location = $R3C7; Size = $R2C2; Image = $PicsArtPhotoStudio; Pattern = "2FE3CB00.PicsArt-PhotoStudio"; Name = "PicsArt"; }; DrawAppButton "Extra25"
	$Extra26 = @{ Location = $R3C8; Size = $R2C2; Image = $Wunderlist; Pattern = "6Wunderkinder.Wunderlist"; Name = "Wunderlist"; }; DrawAppButton "Extra26"
	$Extra27 = @{ Location = $R3C9; Size = $R2C2; Image = $MarchofEmpires; Pattern = "A278AB0D.MarchofEmpires"; Name = "March of Empires: War of Lords"; }; DrawAppButton "Extra27"
	$Extra28 = @{ Location = $R4C1; Size = $R2C2; Image = $FarmVille2CountryEscape; Pattern = "D52A8D61.FarmVille2CountryEscape"; Name = "FarmVille 2: Country Escape"; }; DrawAppButton "Extra28"
	$Extra29 = @{ Location = $R4C2; Size = $R2C2; Image = $RoyalRevolt2; Pattern = "flaregamesGmbH.RoyalRevolt2"; Name = "Royal Revolt 2"; }; DrawAppButton "Extra29"
	$Extra30 = @{ Location = $R4C3; Size = $R2C2; Image = $CaesarsSlotsFreeCasino; Pattern = "Playtika.CaesarsSlotsFreeCasino"; Name = "Caesars Slots Free Casino"; }; DrawAppButton "Extra30"
	$Extra31 = @{ Location = $R4C4; Size = $R2C2; Image = $SlingTV; Pattern = "SlingTVLLC.SlingTV"; Name = "Sling TV"; }; DrawAppButton "Extra31"
	$Extra32 = @{ Location = $R4C5; Size = $R2C2; Image = $TuneInRadio; Pattern = "TuneIn.TuneInRadio"; Name = "TuneIn Radio"; }; DrawAppButton "Extra32"
	$Extra33 = @{ Location = $R4C6; Size = $R2C2; Image = $VegasJackpotSlotsCasinoFreeSlotMac; Pattern = "30947GamesMore.VegasJackpotSlotsCasino-FreeSlotMac"; Name = "Vegas Jackpot Slot Casino"; }; DrawAppButton "Extra33"
	Return
}

Function DrawFeatures {
	$Global:Mode = "Feature"
	$Feature1 = @{ Location = $R1C1; Size = $R2C2; Image = "none"; Pattern = "Browser.InternetExplorer~~~~0.0.11.0"; Name = "Internet Explorer"; }; DrawFoDButton "Feature1"
	$Feature2 = @{ Location = $R1C2; Size = $R2C2; Image = "none"; Pattern = "MathRecognizer~~~~0.0.1.0"; Name = "Math Recognizer"; }; DrawFoDButton "Feature2"
	$Feature3 = @{ Location = $R1C3; Size = $R2C2; Image = "none"; Pattern = "OneCoreUAP.OneSync~~~~0.0.1.0"; Name = "OneSync"; }; DrawFoDButton "Feature3"
	$Feature4 = @{ Location = $R1C4; Size = $R2C2; Image = "none"; Pattern = "OpenSSH.Client~~~~0.0.1.0"; Name = "OpenSSH Client"; }; DrawFoDButton "Feature4"
	$Feature5 = @{ Location = $R1C5; Size = $R2C2; Image = $QuickAssist; Pattern = "App.Support.QuickAssist~~~~0.0.1.0"; Name = "Quick Assist"; }; DrawFoDButton "Feature5"
	$Feature6 = @{ Location = $R1C6; Size = $R2C2; Image = "none"; Pattern = "NetFX3~~~~"; Name = "DotNet 3"; }; DrawFoDButton "Feature6"
	$Feature7 = @{ Location = $R1C7; Size = $R2C2; Image = "none"; Pattern = "Analog.Holographic.Desktop~~~~0.0.1.0"; Name = "Windows Mixed Reality"; }; DrawFoDButton "Feature7"
	$Feature8 = @{ Location = $R1C8; Size = $R2C2; Image = "none"; Pattern = "Accessibility.Braille~~~~0.0.1.0"; Name = "Accessibility Braille"; }; DrawFoDButton "Feature8"
	$Feature9 = @{ Location = $R1C9; Size = $R2C2; Image = "none"; Pattern = "Tools.DeveloperMode.Core~~~~0.0.1.0"; Name = "Developer Mode"; }; DrawFoDButton "Feature9"
	$Feature10 = @{ Location = $R2C1; Size = $R2C2; Image = "none"; Pattern = "Tools.Graphics.DirectX~~~~0.0.1.0"; Name = "Graphic Tools"; }; DrawFoDButton "Feature10"
	$Feature11 = @{ Location = $R2C2; Size = $R2C2; Image = "none"; Pattern = "Microsoft.WebDriver~~~~0.0.1.0"; Name = "Microsoft WebDriver"; }; DrawFoDButton "Feature11"
	$Feature12 = @{ Location = $R2C3; Size = $R2C2; Image = "none"; Pattern = "Msix.PackagingTool.Driver~~~~0.0.1.0"; Name = "MSIX Packaging Tool Driver"; }; DrawFoDButton "Feature12"
	$Feature13 = @{ Location = $R2C4; Size = $R2C2; Image = "none"; Pattern = "RasCMAK.Client~~~~0.0.1.0"; Name = "RAS CMAK Client"; }; DrawFoDButton "Feature13"
	$Feature14 = @{ Location = $R2C5; Size = $R2C2; Image = "none"; Pattern = "RIP.Listener~~~~0.0.1.0"; Name = "RIP Listener"; }; DrawFoDButton "Feature14"
	$Feature15 = @{ Location = $R2C6; Size = $R2C2; Image = "none"; Pattern = "SNMP.Client~~~~0.0.1.0"; Name = "SNMP Client"; }; DrawFoDButton "Feature15"
	$Feature16 = @{ Location = $R2C7; Size = $R2C2; Image = "none"; Pattern = "WMI-SNMP-Provider.Client~~~~0.0.1.0"; Name = "SNMP WMI Provider"; }; DrawFoDButton "Feature16"
	$Feature17 = @{ Location = $R2C8; Size = $R2C2; Image = "none"; Pattern = "OpenSSH.Server~~~~0.0.1.0"; Name = "OpenSSH Server"; }; DrawFoDButton "Feature17"
	$Feature18 = @{ Location = $R2C9; Size = $R2C2; Image = "none"; Pattern = "Print.EnterpriseCloudPrint~~~~0.0.1.0"; Name = "Enterprise Cloud Print"; }; DrawFoDButton "Feature18"
	$Feature19 = @{ Location = $R3C1; Size = $R2C2; Image = "none"; Pattern = "Print.MopriaCloudService~~~~0.0.1.0"; Name = "Mopria Cloud Service"; }; DrawFoDButton "Feature19"
	$Feature20 = @{ Location = $R3C2; Size = $R2C2; Image = "none"; Pattern = "Rsat.ActiveDirectory.DS-LDS.Tools~~~~0.0.1.0"; Name = "AD && LDS Tools"; }; DrawFoDButton "Feature20"
	$Feature21 = @{ Location = $R3C3; Size = $R2C2; Image = "none"; Pattern = "Rsat.BitLocker.Recovery.Tools~~~~0.0.1.0"; Name = "BitLocker Encryption Admin Utilities"; }; DrawFoDButton "Feature21"
	$Feature22 = @{ Location = $R3C4; Size = $R2C2; Image = "none"; Pattern = "Rsat.CertificateServices.Tools~~~~0.0.1.0"; Name = "AD Certificate Services Tools"; }; DrawFoDButton "Feature22"
	$Feature23 = @{ Location = $R3C5; Size = $R2C2; Image = "none"; Pattern = "Rsat.DHCP.Tools~~~~0.0.1.0"; Name = "DHCP Server Tools"; }; DrawFoDButton "Feature23"
	$Feature24 = @{ Location = $R3C6; Size = $R2C2; Image = "none"; Pattern = "Rsat.Dns.Tools~~~~0.0.1.0"; Name = "DNS Server Tools"; }; DrawFoDButton "Feature24"
	$Feature25 = @{ Location = $R3C7; Size = $R2C2; Image = "none"; Pattern = "Rsat.FailoverCluster.Management.Tools~~~~0.0.1.0"; Name = "Failover Clustering Tools"; }; DrawFoDButton "Feature25"
	$Feature26 = @{ Location = $R3C8; Size = $R2C2; Image = "none"; Pattern = "Rsat.FileServices.Tools~~~~0.0.1.0"; Name = "File Services Tools"; }; DrawFoDButton "Feature26"
	$Feature27 = @{ Location = $R3C9; Size = $R2C2; Image = "none"; Pattern = "Rsat.GroupPolicy.Management.Tools~~~~0.0.1.0"; Name = "Group Policy Management Tools"; }; DrawFoDButton "Feature27"
	$Feature28 = @{ Location = $R4C1; Size = $R2C2; Image = "none"; Pattern = "Rsat.IPAM.Client.Tools~~~~0.0.1.0"; Name = "IPAM Client"; }; DrawFoDButton "Feature28"
	$Feature29 = @{ Location = $R4C2; Size = $R2C2; Image = "none"; Pattern = "Rsat.LLDP.Tools~~~~0.0.1.0"; Name = "LLDP Bridging Tools"; }; DrawFoDButton "Feature29"
	$Feature30 = @{ Location = $R4C3; Size = $R2C2; Image = "none"; Pattern = "Rsat.NetworkController.Tools~~~~0.0.1.0"; Name = "Network Controller Management Tools"; }; DrawFoDButton "Feature30"
	$Feature31 = @{ Location = $R4C4; Size = $R2C2; Image = "none"; Pattern = "Rsat.NetworkLoadBalancing.Tools~~~~0.0.1.0"; Name = "Network Load Balancing Tools"; }; DrawFoDButton "Feature31"
	$Feature32 = @{ Location = $R4C5; Size = $R2C2; Image = "none"; Pattern = "Rsat.RemoteAccess.Management.Tools~~~~0.0.1.0"; Name = "Remote Access Management Tools"; }; DrawFoDButton "Feature32"
	$Feature33 = @{ Location = $R4C6; Size = $R2C2; Image = "none"; Pattern = "Rsat.RemoteDesktop.Services.Tools~~~~0.0.1.0"; Name = "Remote Desktop Services Tools"; }; DrawFoDButton "Feature33"
	$Feature34 = @{ Location = $R4C7; Size = $R2C2; Image = "none"; Pattern = "Rsat.ServerManager.Tools~~~~0.0.1.0"; Name = "Server Manager"; }; DrawFoDButton "Feature34"
	$Feature35 = @{ Location = $R4C8; Size = $R2C2; Image = "none"; Pattern = "Rsat.Shielded.VM.Tools~~~~0.0.1.0"; Name = "Shielded VM Tools"; }; DrawFoDButton "Feature35"
	$Feature36 = @{ Location = $R4C9; Size = $R2C2; Image = "none"; Pattern = "Rsat.StorageReplica.Tools~~~~0.0.1.0"; Name = "PowerShell Storage Replica Module"; }; DrawFoDButton "Feature36"
	$Feature37 = @{ Location = $R5C1; Size = $R2C2; Image = "none"; Pattern = "Rsat.VolumeActivation.Tools~~~~0.0.1.0"; Name = "Volume Activation Tools"; }; DrawFoDButton "Feature37"
	$Feature38 = @{ Location = $R5C2; Size = $R2C2; Image = "none"; Pattern = "Rsat.WSUS.Tools~~~~0.0.1.0"; Name = "Server Update Service Tools"; }; DrawFoDButton "Feature38"
	$Feature39 = @{ Location = $R5C3; Size = $R2C2; Image = "none"; Pattern = "Rsat.StorageMigrationService.Management.Tools~~~~0.0.1.0"; Name = "Storage Migration Service Tools"; }; DrawFoDButton "Feature39"
	$Feature40 = @{ Location = $R5C4; Size = $R2C2; Image = "none"; Pattern = "Rsat.SystemInsights.Management.Tools~~~~0.0.1.0"; Name = "PowerShell Systems Insights Module"; }; DrawFoDButton "Feature40"
	$Feature41 = @{ Location = $R5C5; Size = $R2C2; Image = "none"; Pattern = "Microsoft.Windows.StorageManagement~~~~0.0.1.0"; Name = "Storage Management [Windows]"; }; DrawFoDButton "Feature41"
	$Feature42 = @{ Location = $R5C6; Size = $R2C2; Image = "none"; Pattern = "Microsoft.OneCore.StorageManagement~~~~0.0.1.0"; Name = "Storage Management [OneCore]"; }; DrawFoDButton "Feature42"
	$Feature43 = @{ Location = $R5C7; Size = $R2C2; Image = "none"; Pattern = "XPS.Viewer~~~~0.0.1.0"; Name = "XPS Viewer"; }; DrawFoDButton "Feature43"
	Return
}

Function DrawOptions {

	$ButtonOptions1 = New-Object System.Windows.Forms.Button
	$ButtonOptions1.Location = $R1C1
	$ButtonOptions1.Size = $R2C2
	$ButtonOptions1.Text = "REMOVE APPS COMPLETELY"
	$ButtonOptions1.Image = $DefaultImage
	$ButtonOptions1.BackgroundImageLayout = "Zoom"
	$ButtonOptions1.Add_Click({ $Global:Action = "AllUser"; OutputText -Message "`r`nAction Changed To $Action$AllUserNote" })
	$ButtonOptions1.Cursor = $HandCursor
	$PanelOptions.Controls.Add($ButtonOptions1)

	$ButtonOptions2 = New-Object System.Windows.Forms.Button
	$ButtonOptions2.Location = $R1C2
	$ButtonOptions2.Size = $R2C2
	$ButtonOptions2.Text = "Currently Installed Apps"
	$ButtonOptions2.Image = $DefaultImage
	$ButtonOptions2.BackgroundImageLayout = "Zoom"
	$ButtonOptions2.Add_Click({
		CheckInstalledApps
		& cmd /c `"del $AppTextFiles`"
		copy .\current.txt $CurrentUserAppTextFile
		copy .\all.txt $AllUserAppTextFile
		$CurrentUserAppTextFileOutput = Get-Content -Path .\current.txt | Where-Object { $_.Trim() -ne '' } | Out-String
		OutputText -Message "`r`n$CurrentUserAppTextFileOutput"
	})
	$ButtonOptions2.Cursor = $HandCursor
	$PanelOptions.Controls.Add($ButtonOptions2)

	$ButtonOptions3 = New-Object System.Windows.Forms.Button
	$ButtonOptions3.Location = $R1C3
	$ButtonOptions3.Size = $R2C2
	$ButtonOptions3.Text = "Currently Installed Features"
	$ButtonOptions3.Image = $DefaultImage
	$ButtonOptions3.BackgroundImageLayout = "Zoom"
	$ButtonOptions3.Add_Click({
		Waiting
		$CurrentFeaturesOutput = Get-WindowsOptionalFeature -Online | Where State -Like Enabled* | ft | Out-String
		OutputText -Message "`r`n$CurrentFeaturesOutput"
		Ready
	})
	$ButtonOptions3.Cursor = $HandCursor
	$PanelOptions.Controls.Add($ButtonOptions3)

	$ButtonOptions4 = New-Object System.Windows.Forms.Button
	$ButtonOptions4.Location = $R1C4
	$ButtonOptions4.Size = $R2C2
	$ButtonOptions4.Text = "Reinstall Defaults"
	$ButtonOptions4.Image = $DefaultImage
	$ButtonOptions4.BackgroundImageLayout = "Zoom"
	$ButtonOptions4.Add_Click({ ReinstallAll })
	$ButtonOptions4.Cursor = $HandCursor
	$PanelOptions.Controls.Add($ButtonOptions4)

	$ButtonOptions5 = New-Object System.Windows.Forms.Button
	$ButtonOptions5.Location = $R1C5
	$ButtonOptions5.Size = $R2C2
	$ButtonOptions5.Text = "Uninstall Everything"
	$ButtonOptions5.Image = $DefaultImage
	$ButtonOptions5.BackgroundImageLayout = "Zoom"
	$ButtonOptions5.Add_Click({ UninstallAll })
	$ButtonOptions5.Cursor = $HandCursor
	$PanelOptions.Controls.Add($ButtonOptions5)

	$ButtonOptions6 = New-Object System.Windows.Forms.Button
	$ButtonOptions6.Location = $R1C6
	$ButtonOptions6.Size = $R2C2
	$ButtonOptions6.Image = $DefaultImage
	$ButtonOptions6.BackgroundImageLayout = "Zoom"
	If ($NotAdmin) {
		OutputText -Message "Welcome To The Windows 10 App Manager`r`nAdmin Required Please Click On `"Become Admin`"`r`n"
		$ButtonOptions6.Text = "Become Admin"
		$ButtonOptions6.Add_Click({ BecomeAdmin })
	} Else {
		OutputText -Message "Welcome To The Windows 10 App Manager`r`nClick An App To Toggle Its Installation`r`n"
		$ButtonOptions6.Text = "Reload"
		$ButtonOptions6.Add_Click({ ReloadPowerShellFile })
	}
	$ButtonOptions6.Cursor = $HandCursor
	$PanelOptions.Controls.Add($ButtonOptions6)

	$ButtonOptions7 = New-Object System.Windows.Forms.Button
	$ButtonOptions7.Location = $R1C7
	$ButtonOptions7.Size = $R2C2
	$ButtonOptions7.Text = "Change Action"
	$ButtonOptions7.Image = $DefaultImage
	$ButtonOptions7.BackgroundImageLayout = "Zoom"
	$ButtonOptions7.Add_Click({ ChangeAction })
	$ButtonOptions7.Cursor = $HandCursor
	$PanelOptions.Controls.Add($ButtonOptions7)

	$ButtonOptions8 = New-Object System.Windows.Forms.Button
	$ButtonOptions8.Location = $R1C8
	$ButtonOptions8.Size = $R2C2
	$ButtonOptions8.Text = "Change Mode"
	$ButtonOptions8.Image = $DefaultImage
	$ButtonOptions8.BackgroundImageLayout = "Zoom"
	$ButtonOptions8.Add_Click({ ChangeMode })
	$ButtonOptions8.Cursor = $HandCursor
	$PanelOptions.Controls.Add($ButtonOptions8)

	$ButtonOptions9 = New-Object System.Windows.Forms.Button
	$ButtonOptions9.Location = $R1C9
	$ButtonOptions9.Size = $R2C2
	$ButtonOptions9.Text = "Exit"
	$ButtonOptions9.Image = $DefaultImage
	$ButtonOptions9.BackgroundImageLayout = "Zoom"
	$ButtonOptions9.Add_Click({ ExitScript })
	$ButtonOptions9.Cursor = $HandCursor
	$PanelOptions.Controls.Add($ButtonOptions9)

}

Function DrawNotificationTray {

	$DefaultNotificationTray = New-Object System.Windows.Forms.NotifyIcon
	$DefaultNotificationTray.Text = "Windows 10 App / Feature on Demand Script"
	$DefaultNotificationTray.Icon = $WSResetIcon
	$DefaultNotificationTray.Visible = $True
	$DefaultNotificationTray.Add_DoubleClick({ ShowHide })

	$ContextMenuWebsite = New-Object System.Windows.Forms.MenuItem
	$ContextMenuWebsite.Text = "My Website"
	$ContextMenuWebsite.Add_Click({ [system.Diagnostics.Process]::start("https://mariomasta64.me/") })

	$ContextMenuReload = New-Object System.Windows.Forms.MenuItem
	$ContextMenuReload.Text = "Reload Script"
	$ContextMenuReload.Add_Click({ ReloadPowerShellFile })

	$ContextMenuExit = New-Object System.Windows.Forms.MenuItem
	$ContextMenuExit.Text = "Exit"
	$ContextMenuExit.Add_Click({ ExitScript })

	$DefaultNotificationTray.ContextMenu = New-Object System.Windows.Forms.ContextMenu
	$DefaultNotificationTray.ContextMenu.MenuItems.Add($ContextMenuWebsite)
	$DefaultNotificationTray.ContextMenu.MenuItems.Add("-");
	$DefaultNotificationTray.ContextMenu.MenuItems.Add($ContextMenuReload)
	$DefaultNotificationTray.ContextMenu.MenuItems.Add("-");
	$DefaultNotificationTray.ContextMenu.MenuItems.Add($ContextMenuExit)

}

Function CheckInstalledApps {
	Waiting
	Get-AppxPackage | ft Name -AutoSize | Out-File -FilePath .\current.txt
	Get-AppxPackage -AllUsers | ft Name -AutoSize | Out-File -FilePath .\all.txt
	Ready
	Return
}
Function UninstallApp {
	Waiting
	Get-AppxPackage *$args* | Foreach {
		OutputText -Message "`r`nUninstalling $_"
		Remove-AppxPackage "$_"
		OutputText -Message " - Done"
	}
	Ready
	Return
}
Function ReinstallApp {
	Waiting
	Get-AppxPackage -AllUsers *$args* | Foreach {
		OutputText -Message "`r`nReinstalling $_"
		Add-AppxPackage -DisableDevelopmentMode -Register "$($_.InstallLocation)\AppXManifest.xml"
		OutputText -Message " - Done"
	}
	Ready
	Reload
	Return
}
Function UninstallAll {
	Waiting
	KillExplorer
	Get-AppxPackage | Foreach {
		OutputText -Message "`r`nUninstalling $_"
		Remove-AppxPackage "$_"
		OutputText -Message " - Done"
	}
	StartExplorer
	Ready
	ReloadPowerShellFile
	Return
}
Function ReinstallAll {
	Waiting
	KillExplorer
	Get-AppxPackage -AllUsers | Foreach {
		OutputText -Message "`r`nReinstalling $_"
		Add-AppxPackage -DisableDevelopmentMode -Register "$($_.InstallLocation)\AppXManifest.xml"
		OutputText -Message " - Done"
	}
	StartExplorer
	Ready
	ReloadPowerShellFile
	Return
}

Function ShowHide {
	if ($DefaultForm.WindowState -eq "Normal") {
		$DefaultForm.WindowState = "Minimized"
		$DefaultForm.ShowInTaskbar = $False
	} else {
		$DefaultForm.WindowState = "Normal"; 
		$DefaultForm.ShowInTaskbar = $True
	}
}

Function OutputText { Param ($Message); $DefaultTextBox.AppendText("$Message"); $DefaultTextBox.Refresh(); Return; };
Function ClearText { $DefaultTextBox.Text = ""; Return; };

Function OpenStartMenu { Waiting; [KeyboardSend.KeyboardSend]::KeyDown("LWin"); [KeyboardSend.KeyboardSend]::KeyUp("LWin"); Ready; Return; };
Function KillExplorer { Waiting; & cmd /c `"taskkill /f /im explorer.exe`"; Ready; Return; };
Function StartExplorer { Waiting; & explorer.exe; Ready; Return; };
# Function ExitScript { AppStarting; [environment]::exit(0); Return; };
Function ExitScript { $DefaultNotificationTray.Visible = $False; $DefaultNotificationTray.Dispose(); $consolePtr.Close(); Stop-Process $PID };

Function ReloadPowerShellFile { Waiting; & $BatchFileLocation; ExitScript; Return; };
Function BecomeAdmin { Waiting; Start-Process powershell.exe "-Windowstyle Hidden -NoProfile -ExecutionPolicy Bypass -File `"$PSCommandPath`"" -Verb RunAs; ExitScript; Return; };

Function Waiting { $DefaultForm.Cursor = $WaitCursor; Return; };
Function AppStarting { $DefaultForm.Cursor = $AppStarting; Return; };
Function Ready { $DefaultForm.Cursor = $Default; Return; };

Function DrawAppButton {

	# Import Button Data #
	$Temp = "$args"
	
	$PanelType = Get-Variable -Name "Panel$Mode" -Value
	$LocationType = (Get-Variable -Name "$Temp" -Value).Location
	$SizeType = (Get-Variable -Name "$Temp" -Value).Size
	$ImageType = (Get-Variable -Name "$Temp" -Value).Image
	$PatternType = (Get-Variable -Name "$Temp" -Value).Pattern
	$NameType = (Get-Variable -Name "$Temp" -Value).Name

	# Make Button Object #
	$ButtonType = New-Object System.Windows.Forms.Button
	
	# Store Variables
    $ButtonType | Add-Member -NotePropertyMembers @{ LocationTemp = $LocationType }
    $ButtonType | Add-Member -NotePropertyMembers @{ SizeTemp = $SizeType }
    $ButtonType | Add-Member -NotePropertyMembers @{ ImageTemp = $ImageType }
    $ButtonType | Add-Member -NotePropertyMembers @{ PatternTemp = $PatternType }
    $ButtonType | Add-Member -NotePropertyMembers @{ NameTemp = $NameType }

	# Button Stuff #
	$ButtonType.Location = $LocationType
	$ButtonType.Size = $SizeType
	if ("$ImageType" -ne "none") { $ButtonType.BackgroundImage = $ImageType } else { $ButtonType.Text = "$NameType"; $ButtonType.Image = $DefaultImage }
	$ButtonType.BackgroundImageLayout = "Zoom"
	# Note: When Inside Button Add_Click Can Use "$This" Instead Of $ButtonType
	$ButtonType.Add_Click({
	
		# Retrieve Variables
		$LocationType = "$($This.LocationTemp)"
		$SizeType = "$($This.SizeTemp)"
		$ImageType = "$($This.ImageTemp)"
		$PatternType = "$($This.PatternTemp)"
		$NameType = "$($This.NameTemp)"
		
		# Toggle Installation #
		$SEL = Get-AppxPackage *$PatternType*
		if ($SEL -ne $null) { UninstallApp "$PatternType" } else { ReinstallApp "$PatternType" }
		
		# Update Button Based On Installation Status [When Clicked] #
		$SEL = Get-AppxPackage -AllUsers *$PatternType*
		if ($SEL -eq $null) { $This.Text = "$NameType"; $This.Enabled = $False; $This.Image = $DefaultImage }
		$SEL = Get-AppxPackage *$PatternType*
		if ($SEL -eq $null) { $This.FlatStyle = $FlatButton } else { $This.FlatStyle = $PopButton }
		
		# OpenStartMenu
		
	})
	
	# Update Button Based On Installation Status [When Drawn] #
	$SEL = Get-Content .\all.txt | Select-String "$PatternType"
	if ($SEL -eq $null) { $ButtonType.Text = "$NameType"; $ButtonType.Enabled = $False; $ButtonType.Image = $DefaultImage }
	$SEL = Get-Content .\current.txt | Select-String "$PatternType"
	if ($SEL -eq $null) { $ButtonType.FlatStyle = $FlatButton } else { $ButtonType.FlatStyle = $PopButton}
	$ButtonType.Cursor = $HandCursor; $PanelType.Controls.Add($ButtonType)
	
	Return

}

Function DrawFoDButton {

	# Import Button Data #
	$Temp = "$args"
	
	$PanelType = Get-Variable -Name "Panel$Mode" -Value
	$LocationType = (Get-Variable -Name "$Temp" -Value).Location
	$SizeType = (Get-Variable -Name "$Temp" -Value).Size
	$ImageType = (Get-Variable -Name "$Temp" -Value).Image
	$PatternType = (Get-Variable -Name "$Temp" -Value).Pattern
	$NameType = (Get-Variable -Name "$Temp" -Value).Name

	# Make Button Object #
	$ButtonType = New-Object System.Windows.Forms.Button
	
	# Store Variables
    $ButtonType | Add-Member -NotePropertyMembers @{ LocationTemp = $LocationType }
    $ButtonType | Add-Member -NotePropertyMembers @{ SizeTemp = $SizeType }
    $ButtonType | Add-Member -NotePropertyMembers @{ ImageTemp = $ImageType }
    $ButtonType | Add-Member -NotePropertyMembers @{ PatternTemp = $PatternType }
    $ButtonType | Add-Member -NotePropertyMembers @{ NameTemp = $NameType }

	# Button Stuff #
	$ButtonType.Location = $LocationType
	$ButtonType.Size = $SizeType
	if ("$ImageType" -ne "none") { $ButtonType.BackgroundImage = $ImageType } else { $ButtonType.Text = "$NameType"; $ButtonType.Image = $DefaultImage }
	$ButtonType.BackgroundImageLayout = "Zoom"
	# Note: When Inside Button Add_Click Can Use "$This" Instead Of $ButtonType
	$ButtonType.Add_Click({
	
		# Retrieve Variables
		$LocationType = "$($This.LocationTemp)"
		$SizeType = "$($This.SizeTemp)"
		$ImageType = "$($This.ImageTemp)"
		$PatternType = "$($This.PatternTemp)"
		$NameType = "$($This.NameTemp)"
		
		# Uninstall Feature On Demand
		$This.Cursor = $WaitCursor
		Remove-WindowsCapability -online -name $PatternType
		$This.Cursor = $HandCursor

		# OpenStartMenu
		
	})
	
	$ButtonType.Cursor = $HandCursor; $PanelType.Controls.Add($ButtonType)
	
	Return

}



Redraw



# THANK YOU #

# https://stackoverflow.com/users/8523330/rokumaru #
# https://stackoverflow.com/users/6811411/lotpings #
# https://stackoverflow.com/questions/56502562/how-do-i-store-information-in-a-variable-name-that-contains-a-variable #

# https://stackoverflow.com/users/45375/mklement0 #
# https://stackoverflow.com/questions/56518860/expand-all-variables-inside-add-click-inside-Function/56519814#56519814 #

# https://github.com/stefanstranger #
# https://github.com/stefanstranger/PowerShell/blob/master/WinKeys.ps1 #

# https://community.idera.com/members/nohandle #
# https://community.idera.com/database-tools/powershell/powertips/b/tips/posts/launching-powershell-hidden #

# https://www.powershellbros.com/create-first-powershell-gui-tool/ #

# https://www.reddit.com/r/PowerShell/comments/7gxbc8/writehost_output_to_formstextbox/ #

# https://stackoverflow.com/questions/15070040/system-windows-forms-groupbox-hide-frame #

# https://stackoverflow.com/questions/50134318/combine-multiple-conditions-in-if-statement #

# https://community.idera.com/database-tools/powershell/ask_the_experts/f/learn_powershell_from_don_jones-24/18148/hide-show-form-buttons-based-on-selection #

# https://stackoverflow.com/questions/49936812/powershell-get-content-to-messagebox-keep-newlines #

# https://docs.microsoft.com/en-us/dotnet/api/system.windows.forms.form.showintaskbar?view=netframework-4.8 #



$DefaultForm.Add_Shown({$DefaultForm.Activate()})
[void] $DefaultForm.ShowDialog()